# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/04_graph.ipynb.

# %% auto 0
__all__ = ['build_network', 'plot_trade_network']

# %% ../nbs/04_graph.ipynb 3
import pandas as pd
import networkx as nx
from itertools import chain

# %% ../nbs/04_graph.ipynb 5
def build_network(trade_df: pd.DataFrame) -> nx.Graph:
    """Builds a undirected graph with trades as edges, wallets as nodes and trade value (price) as edge weight"""
    edges = [(s,b,{'weight':p}) for s,b,p in trade_df[['seller', 'buyer','price']].to_records(index=False)]
    G = nx.DiGraph()
    G.add_edges_from(edges)
    return G

def plot_trade_network(trade_g: nx.Graph): nx.draw(trade_g)
